# Contributing

First of all, thank you for taking the time to contribute! :tada:

The following are a set of guidelines to help you with contributing to the project. If you feel the need to deviate from these guidelines, using your best judgement, feel free to do so (or recommend changes to the guidelines).

## Code of Conduct

This project and everyone participating in it is governed by the project's [Code of Conduct](CODE_OF_CONDUCT.md). By participating, you are expected to uphold this code. Please report unacceptable behavior to help@exein.io.

## Questions

For the time being to ask questions it is best to open an issue and assigning it the `question` tag.

## Contribute

### Reporting a bug

Before reporting a bug, please take the time to first review [existing bugs](../../issues?q=is%3Aissue+label%3Abug) to avoid creating duplicating issues, causing split discussions. Otherwise, you are free to open a bug report using the [issue template](.github/ISSUE_TEMPLATE/BUG-REPORT.yaml) provided.

Here are some guidelines for reporting a good bug:

* Provide a clear title that adequately summarizes the issue;
* Use clear and concise language throughout the bug report;
* Provide all the steps required to reproduce the bug -- try be very specific;
* Where possible, provide a minimal reproducible example (e.g. a reduced code snippet that exhibits the same bug);
* Where possible, explain what the expected behaviour should be in contract to the current behaviour.

### Suggesting features or enhancements

We want to keep improving the project's feature set alongside its existing features. If you have any feedback on how we may achieve that you are more than welcome to create a GitHub issue using the `feature` label! 

> Similar to bug issues, please make sure that the feature or enhancement has not already been requested from the list of [features](../../issues?q=is%3Aissue+label%3Aenhancement).

Here are some guidelines for submitting a feature request or enhancement:

* Try to assess whether or not the feature or enhancement falls within the scope of the project;
* Explain clearly and concisely the feature or enhancement you are requesting;
* Where applicable, explain why you would like to see this change happen (what benefit does it provide?).

### Pull requests

All changes need to be made through pull requests that are reviewed and merged. When submitting a pull request be sure to follow the pull request [template](.github/PULL_REQUEST_TEMPLATE.md). There are a couple goals we aim to achieve with a pull request.

* Maintain a high level of code quality;
* Fix bugs that are important to end-users (i.e. our peers);
* Enhance the performance or maintanability of the project;
* Introduce a feature or enhancement that is of value to end-users.

If you are unsure about a pull request, feel free to submit it either way as a draft. The community will be more than happy to discuss the changes and help guide you through to merging your first pull request!
